#include <gtkmm.h>
#include <libglademm.h>
#include "simpledraw.h"

// ---------------------------------------------------------
// wrap a GtkDrawingArea* GObject "upward" to a SimpleDraw*
static Glib::ObjectBase* simpledraw_wrap_new(GObject* o)
{
  return manage(new SimpleDraw((GtkDrawingArea*)(o)));
}

// ---------------------------------------------------------
// get the GType of SimpleDraw. if not yet registered, do it now
GType simpledraw_get_type()
{
  static GType gtype = 0;
   
  if (!gtype) {
    SimpleDraw* dummy = new SimpleDraw();
    gtype = G_OBJECT_TYPE(dummy->gobj());
    delete( dummy ); 

    Glib::wrap_register(gtype, &simpledraw_wrap_new);
  }

  return gtype;
}

// ---------------------------------------------------------
// use this as an init-function in the corresponding catalog file
extern "C" void simpledraw_init()
{
  Gtk::Main::init_gtkmm_internals();
  simpledraw_get_type();
}

// ---------------------------------------------------------
// glade has it's own idea of what the *_get_type() - function should be called
extern "C" GType gtkmm___custom_object_simpledraw_get_type()
{
  return simpledraw_get_type();
}

// ---------------------------------------------------------
// use this as a postcreate-function in the corresponding catalog file, or else
// glade will only show the base widget in it's interface designer
extern "C" void simpledraw_postcreate(GObject *object, int reason)
{
  Glib::ObjectBase* ob = simpledraw_wrap_new(object);
}

// ---------------------------------------------------------
// when linked to an application (using libglade), this also registers the type
extern "C" void glade_module_register_widgets()
{
  simpledraw_get_type();  
}
